<?php
/*
* iRC HTML History script [ANSI]
* by
*  2005 CriS
*  2012 Skurat Denis (a.k.a. Dionys)
* @contact: skiner@inbox.ru
* 
* for MSP (MBot) 1.0.0.0 or Higher
*/

/* CONFIGURATION */
define('SCRIPT_NAME',				'iRC HTML Log');		// Script name.
define('SCRIPT_VERSION',			'1.0.2.3');				// Script version.
define('SCRIPT_CFG',				'iRC_HTML_Log');		// Script config section.
define('_DEBUG',					false);					// Debug
define('_TABSRMM',					true);					// Using tabsrmm?
define('MIRANDA_PATH',				realpath('./'));
define('INCLUDE_PATH',				MIRANDA_PATH .'/mbot/scripts/include');
define('WWW_SHORT_PATH',			'/mbot/www/irc_html_log');
define('WWW_FULL_PATH',				MIRANDA_PATH . WWW_SHORT_PATH);
define('WWW_STYLE',					WWW_FULL_PATH .'/history.css');
define('WWW_STYLE_DEF',				WWW_FULL_PATH .'/history_default.css');
define('SYM_NEWLINE',				chr(0x0D).chr(0x0A));	// New Line
define('SYM_TAB',					chr(0x09));				// Tabulation
define('GC_EVENT_JOIN',				0x0001);				// (1)		iRC Event
define('GC_EVENT_PART',				0x0002);				// (2)		iRC Event
define('GC_EVENT_QUIT',				0x0004);				// (4)		iRC Event
define('GC_EVENT_KICK',				0x0008);				// (8)		iRC Event
define('GC_EVENT_NICK',				0x0010);				// (16)		iRC Event
define('GC_EVENT_NOTICE',			0x0020);				// (32)		iRC Event
define('GC_EVENT_MESSAGE',			0x0040);				// (64)		iRC Event
define('GC_EVENT_TOPIC',			0x0080);				// (128)	iRC Event
define('GC_EVENT_INFORMATION',		0x0100);				// (256)	iRC Event
define('GC_EVENT_ACTION',			0x0200);				// (512)	iRC Event
define('GC_EVENT_ADDSTATUS',		0x0400);				// (1024)	iRC Event
define('GC_EVENT_REMOVESTATUS',		0x0800);				// (2048)	iRC Event
define('GC_EVENT_CHUID',			0x1000);				// (4096)	iRC Event
define('GC_EVENT_CHANGESESSIONAME',	0x1001);				// (4097)	iRC Event
define('GC_EVENT_ADDGROUP',			0x1002);				// (4098)	iRC Event
define('GC_EVENT_SETITEMDATA',		0x1003);				// (4099)	iRC Event
define('GC_EVENT_GETITEMDATA',		0x1004);				// (4100)	iRC Event
define('GC_EVENT_CONTROL',			0x1005);				// (4101)	iRC Event
define('GC_EVENT_SETSBTEXT',		0x1006);				// (4102)	iRC Event
define('GC_EVENT_ACK',				0x1007);				// (4103)	iRC Event
define('GC_EVENT_SENDMESSAGE',		0x1008);				// (4104)	iRC Event
define('GC_EVENT_SETSTATUSEX',		0x1009);				// (4105)	iRC Event
define('GC_EVENT_SETCONTACTSTATUS',	0x100A);				// (4106)	iRC Event
define('BS_CHECKBOX',				0x00000002);			// Dialog styles
define('WS_BORDER',					0x00800000);			// Dialog styles 
define('ES_AUTOVSCROLL',			0x004);					// Dialog styles
define('SS_LEFT',					0x00000000);			// Dialog styles
define('SS_SUNKEN',					0x00001000);			// Dialog styles
define('BF_MIDDLE',					0x0800);				// Dialog styles
define('BS_FLAT',					0x00008000);			// Dialog styles
define('BS_VCENTER',				0x00000C00);			// Dialog styles
define('DC_STATIC',					1);						// Dialog controls
define('DC_BUTTON',					2);						// Dialog controls
define('DC_EDITBOX',				3);						// Dialog controls
define('DC_COMBOBOX',				4);						// Dialog controls
define('DC_IPBOX',					5);						// Dialog controls
define('DC_LISTVIEW',				6);						// Dialog controls
define('DC_PROGRESSBAR',			7);						// Dialog controls
define('DC_TREEVIEW',				8);						// Dialog controls

include (INCLUDE_PATH . '/dir.libphp4.php');

$regexp['irc']			= array('~&~',		'~<~',	'~>~',	'~%c(\d)(\d)%f(\d)(\d)~',			'~%C%F~',	'~%Cf(\d)(\d)~',			'~%c(\d)(\d)~',				'~%C~',		'~%b~',			'~%B~',	'~%u~',			'~%U~',	'~%i~',			'~%I~',	'~%r~',	'~%%~');	
$regexp['html']			= array('&amp;',	'&lt;',	'&gt;',	'<span class="c\\1\\2 f\\3\\4">',	'</span>',	'<span class="f\\1\\2">',	'<span class="c\\1\\2">',	'</span>',	'<b class=b>',	'</b>',	'<u class=u>',	'</u>',	'<i class=i>',	'</i>',	'',		'%');		
$regexp_url['irc']		= "`((http|ftp)+(s)?:(//)|(www\.))((\w|\.|\-|_)+)(/)?(\S+)?`i";
$regexp_url['html']		= "<a href=\"\\0\" title=\"\\0\">\\5\\6</a>";
$regexp_url['html_l']	= "<a href=\"\\0\" title=\"\\0\">\\0</a>";

function mbot_load()
{
	if (MBOT_VERSION >= 0x01000000)
	{
		$icon_miranda	= mb_IconLoadSkin(SKINICON_OTHER_MIRANDA);
		$icon_mbot		= 0;

		mb_SelfRegister(IRC_EVENT_GUI_IN, 0);
		mb_SelfSetInfo(SCRIPT_NAME .' v.'. SCRIPT_VERSION .' by Dionys');
		mb_Echo(SCRIPT_NAME .' v.'. SCRIPT_VERSION .' .'. SYM_NEWLINE);
		mb_MenuAdd(SCRIPT_NAME, 0, 'iRC_HTML_Log_Config', $icon_mbot);

		if (!@mb_CSettingGet(NULL, SCRIPT_CFG, 'Chat_fic'))
		{
			mb_CSettingAdd(NULL, SCRIPT_CFG, DBVT_BYTE, 'Chat_fic', 0x00);
		}
		if (!@mb_CSettingGet(NULL, SCRIPT_CFG, '_version'))
		{
			mb_CSettingAdd(NULL, SCRIPT_CFG, DBVT_ASCIIZ, '_version', SCRIPT_VERSION);
		}
		if (@mb_CSettingGet(NULL, SCRIPT_CFG, '_version') != SCRIPT_VERSION)
		{
			mb_CSettingSet(NULL, SCRIPT_CFG, '_version', SCRIPT_VERSION);
		}
		if (!@mb_CSettingGet(NULL, SCRIPT_CFG, 'LinkStyle'))
		{
			mb_CSettingAdd(NULL, SCRIPT_CFG, DBVT_BYTE, 'LinkStyle', 0x00);
		}

		iRC_HTML_Log_CheckStyle();
	}
	else
	{
		mb_echo(SCRIPT_NAME .': This scripts requires mBot 1.0.0.0 or later!');
	}
}

function irc_GuiIn($module, $eventtype, $channel, $nick, $text)
{
	GLOBAL	$regexp, $regexp_url;

	$info			= array();
	$channel		= explode(' ', $channel);
	$channel		= $channel[0];
	$eventtype		= intval($eventtype);
	$output			= '';
	$lasteventvar	= '/'. SCRIPT_CFG .'/'. $module .'/'. $channel .'/lastevent';
	$joinedvar		= '/'. SCRIPT_CFG .'/'. $module .'/'. $channel .'/joined';
	$usersvar		= '/'. SCRIPT_CFG .'/'. $module .'/'. $channel .'/users';
	$var_lastevent	= @mt_getvar("$lasteventvar");	
	$var_joined		= @mt_getvar("$joinedvar");	
	$var_users		= @mt_getvar("$usersvar");

	mt_setvar("$lasteventvar", $eventtype, 1, 0);

	if ($var_joined === FALSE)
	{
		mt_setvar("$joinedvar", 'no', 1, 0);
	}

	if ($var_users === FALSE)
	{
		mt_setvar("$usersvar", array(), 1, 0);
	}

	$info['profile']	= mb_SysGetProfileName(); 
	$info['logdir']		= mb_CSettingGet(NULL, 'Chat', 'LogDirectory');

	if (preg_match("~^([a-zA-Z][:]|[\\\][\\\])~i", $info['logdir']))
	{
		$info['log2'] = $info['logdir'];
	}
	else
	{
		$info['log2'] = MIRANDA_PATH .'/'. $info['logdir'];
	}

	if (preg_match("~^(\\\)~i", substr($info['logdir'], -1)))
	{
		$info['log2'] = substr($info['log2'], 0, -1);
	}

	$GuiInArr = mb_IrcGetGuiDataIn(); //($Type, $Channel, $Text, $Nick, $UniqueId, $Status, $ExtraInfo, $IsMe, $AddToLog, $Timestamp, $wParam);
	if (_DEBUG)
	{
		mb_echo(SCRIPT_NAME .' DEBUG:'. SYM_NEWLINE . $module .'-GI-'. $eventtype .'|'. $channel .'-'. $nick .'|'. $GuiInArr[4] .'|'. $GuiInArr[5] .'|'. $GuiInArr[6] .'|'. $GuiInArr[7] .'|'. $GuiInArr[8] .'|'. $GuiInArr[9] .'|'. $GuiInArr[10] .':'. $text . SYM_NEWLINE);
	}

	$timestamp	= $GuiInArr[9];
	$is_me		= $GuiInArr[7];
	$status		= $GuiInArr[5];
	if ($GuiInArr[6] != '')
	{
		$info['mask'] = ' ('. $GuiInArr[4] .'!'. $GuiInArr[6] .')';
	}

	$info['nick']		= $nick;
	$info['text']		= $text;
	$info['date']		= date("Y.m.d", $timestamp);
	$info['date_dt']	= date("[Y.m.d", $timestamp) .'&nbsp;'. date("H:i:s]", $timestamp) .'&nbsp;';
	$info['date_dir']	= date("Y\\m,F\\d,l\\", $timestamp);
	$info['date_dir_y']	= date("Y", $timestamp);
	$info['date_dir_m']	= date("m,F", $timestamp);
	$info['date_dir_d']	= date("d,l", $timestamp);
	$info['network']	= str_replace(' ', '-', mb_IrcGetData($module, 'Network'));
	$info['mynick']		= mb_IrcGetData($module, 'OwnNick');

	if ($eventtype != GC_EVENT_ADDSTATUS && $eventtype != GC_EVENT_REMOVESTATUS)
	{
		$info['text'] = preg_replace($regexp['irc'], $regexp['html'], $info['text']);
	}

	if (@mb_CSettingGet(NULL, SCRIPT_CFG, 'LinkStyle') == 0x00)
	{
		$info['text'] = preg_replace($regexp_url['irc'], $regexp_url['html'], $info['text']);
	}
	else if (@mb_CSettingGet(NULL, SCRIPT_CFG, 'LinkStyle') == 0x01)
	{
		$info['text'] = preg_replace($regexp_url['irc'], $regexp_url['html_l'], $info['text']);
	}
	else
	{
		$info['text'] = preg_replace($regexp_url['irc'], $regexp_url['html'], $info['text']);
		mb_CSettingAdd(NULL, SCRIPT_CFG, DBVT_BYTE, 'LinkStyle', 0x00);
	}

	switch($eventtype)
	{
		case GC_EVENT_JOIN:
		{
			if ($info['nick'] == $info['mynick'])
			{
				$output .= '<tr><td class=Timestamp>'. $info['date_dt'] .'</td><td class=Join>'. mb_SysTranslate('You have joined ['. $channel .']') .'</td></tr>'. SYM_NEWLINE;
				iRC_HTML_Log_LogSave($module, $channel, $info, $output);

				mt_setvar("$joinedvar", 'yes', 1, 0);
			}
			else
			{
				if (!empty($info['mask']))
				{
					$nick_full = $info['nick'] . $info['mask'];
				}
				else
				{
					$nick_full = $info['nick'];
				}

				$output .= '<tr><td class=Timestamp>'. $info['date_dt'] .'</td><td class=Join>'. mb_SysTranslate($nick_full .' has joined') .'</td></tr>'. SYM_NEWLINE;
				iRC_HTML_Log_LogSave($module, $channel, $info, $output);

				iRC_HTML_Log_SetUsers($module, $eventtype, $channel, $info);
			}

			break;
		}

		case GC_EVENT_PART:
		{
			if ($info['text'])
			{
				$t = ': '. $info['text'];
			}

			if (!empty($info['mask']))
			{
				$nick_full = $info['nick'] . $info['mask'];
			}
			else
			{
				$nick_full = $info['nick'];
			}

			$output .= '<tr><td class=Timestamp>'. $info['date_dt'] .'</td><td class=Part>'. mb_SysTranslate($nick_full .' has left') . $t .'</td></tr>'. SYM_NEWLINE;
			iRC_HTML_Log_LogSave($module, $channel, $info, $output);

			if ($info['nick'] == $info['mynick'])
			{
				mt_setvar("$joinedvar", 'no', 1, 0);
			}
			else
			{
				iRC_HTML_Log_SetUsers($module, $eventtype, $channel, $info);
			}

			break;
		}

		case GC_EVENT_QUIT:
		{
			if ($info['text'])
			{
				$t = ': '. $info['text'];
			}

			if (!empty($info['mask']))
			{
				$nick_full = $info['nick'] . $info['mask'];
			}
			else
			{
				$nick_full = $info['nick'];
			}

			$output .= '<tr><td class=Timestamp>'. $info['date_dt'] .'</td><td class=Disconnect>'. mb_SysTranslate($nick_full .' has disconnected') . $t .'</td></tr>'. SYM_NEWLINE;
			iRC_HTML_Log_LogSaveToAllByUser($module, $channel, $info, $output);

			iRC_HTML_Log_SetUsers($module, $eventtype, $channel, $info);

			break;
		}

		case GC_EVENT_KICK:
		{
			if ($info['text'])
			{
				$t = ': '. $info['text'];
			}

			if (!empty($info['mask']))
			{
				$nick_full = $info['nick'] . $info['mask'];
			}
			else
			{
				$nick_full = $info['nick'];
			}

			$output .= '<tr><td class=Timestamp>'. $info['date_dt'] .'</td><td class=Kick>'. mb_SysTranslate($status .' kicked '. $nick_full) . $t .'</td></tr>'. SYM_NEWLINE;
			iRC_HTML_Log_LogSave($module, $channel, $info, $output);

			iRC_HTML_Log_SetUsers($module, $eventtype, $channel, $info);

			break;
		}

		case GC_EVENT_NICK:
		{
			if ($info['text'] == $info['mynick'] || $info['nick'] == $info['mynick'])
			{
				$output .= '<tr><td class=Timestamp>'. $info['date_dt'] .'</td><td class=NickChange>'. mb_SysTranslate('You are now known as '. $info['text']) .'</td></tr>'. SYM_NEWLINE;
				iRC_HTML_Log_LogSaveToAll($module, $channel, $info, $output);
			}
			else
			{
				if (!empty($info['mask']))
				{
					$nick_full = $info['nick'] . $info['mask'];
				}
				else
				{
					$nick_full = $info['nick'];
				}

				$output .= '<tr><td class=Timestamp>'. $info['date_dt'] .'</td><td class=NickChange>'. mb_SysTranslate($nick_full .' is now known as '. $info['text']) .'</td></tr>'. SYM_NEWLINE;
				iRC_HTML_Log_LogSaveToAllByUser($module, $channel, $info, $output);
			}

			iRC_HTML_Log_SetUsers($module, $eventtype, $channel, $info);

			break;
		}

		case GC_EVENT_NOTICE:
		{
			$output .= '<tr><td class=Timestamp>'. $info['date_dt'] .'</td><td class=Notice>'. mb_SysTranslate('Notice from '. $info['nick'] .': '. $info['text']) .'</td></tr>'. SYM_NEWLINE;

			if (!empty($nick) && (strtolower($nick) != 'chanserv' || strtolower($nick) != 'nickserv' || strtolower($nick) != 'memoserv'))
			{
				iRC_HTML_Log_LogSaveToAllByUser($module, $channel, $info, $output);
			}
			else
			{
				iRC_HTML_Log_LogSave($module, $channel, $info, $output);
			}

			break;
		}

		case GC_EVENT_MESSAGE:
		{
			if ($info['nick'] == $info['mynick'])
			{
				$output .= '<tr><td class=Timestamp>'. $info['date_dt'] .'</td><td class=Outgoing><span class=MyNick>'. $info['nick'] .':</span> '. $info['text'] .'</td></tr>'. SYM_NEWLINE;
			}
			else
			{
				if (stripos($info['text'], $info['mynick']) !== FALSE)
				{
					$output .= '<tr><td class=Timestamp>'. $info['date_dt'] .'</td><td class=Incoming><span class=Nicks>'. $info['nick'] .':</span> <span class=Hilight>'. $info['text'] .'</span></td></tr>'. SYM_NEWLINE;
				}
				else
				{
					$output .= '<tr><td class=Timestamp>'. $info['date_dt'] .'</td><td class=Incoming><span class=Nicks>'. $info['nick'] .':</span> '. $info['text'] .'</td></tr>'. SYM_NEWLINE;
				}
			}

			iRC_HTML_Log_LogSave($module, $channel, $info, $output);

			break;
		}

		case GC_EVENT_TOPIC:
		{
			if ($info['nick'])
			{
				$t = '(set by '. $info['nick'] .')';
			}

			$output .= '<tr><td class=Timestamp>'. $info['date_dt'] .'</td><td class=Topic>'. mb_SysTranslate('The topic is "'. $info['text'] .'"'). $t .'</td></tr>'. SYM_NEWLINE;
			iRC_HTML_Log_LogSave($module, $channel, $info, $output);

			break;
		}

		case GC_EVENT_INFORMATION:
		{
			$channel = 'Global';

			$output .= '<tr><td class=Timestamp>'. $info['date_dt'] .'</td><td class=Info>'. $info['text'] .'</td></tr>'. SYM_NEWLINE;
			iRC_HTML_Log_LogSave($module, $channel, $info, $output);

			break;
		}

		case GC_EVENT_ACTION:
		{
			$output .= '<tr><td class=Timestamp>'. $info['date_dt'] .'</td><td class=Action>'. mb_SysTranslate($nick .' '. $info['text']) .'</td></tr>'. SYM_NEWLINE;
			iRC_HTML_Log_LogSave($module, $channel, $info, $output);

			break;
		}

		case GC_EVENT_ADDSTATUS:
		{
			if (!empty($info['mask']))
			{
				$nick_full = $info['nick'] . $info['mask'];
			}
			else
			{
				$nick_full = $info['nick'];
			}

			$output .= '<tr><td class=Timestamp>'. $info['date_dt'] .'</td><td class=AddStatus>'. mb_SysTranslate($info['text'] .' enables "'. $status .'" status for '. $nick_full) .'</td></tr>'. SYM_NEWLINE;
			iRC_HTML_Log_LogSave($module, $channel, $info, $output);

			break;
		}

		case GC_EVENT_REMOVESTATUS:
		{
			if (!empty($info['mask']))
			{
				$nick_full = $info['nick'] . $info['mask'];
			}
			else
			{
				$nick_full = $info['nick'];
			}

			$output .= '<tr><td class=Timestamp>'. $info['date_dt'] .'</td><td class=RemStatus>'. mb_SysTranslate($info['text'] .' disables "'. $status .'" status for '. $nick_full) .'</td></tr>'. SYM_NEWLINE;
			iRC_HTML_Log_LogSave($module, $channel, $info, $output);

			break;
		}

		case GC_EVENT_SETCONTACTSTATUS:
		{
			if ($var_joined === 'getuserlist')
			{
				iRC_HTML_Log_BackupUsers($module, $channel);
			}

			break;
		}

		default:
			break;
	}

	if ($var_joined == 'yes')
	{
		mt_setvar("$joinedvar", 'getuserlist', 1, 0);
		iRC_HTML_Log_BackupUsers($module, $channel);
	}
	else if ($var_joined == 'getuserlist')
	{
		if (($eventtype != GC_EVENT_SETCONTACTSTATUS && $var_lastevent == GC_EVENT_JOIN) || ($eventtype != GC_EVENT_SETCONTACTSTATUS && $var_lastevent == GC_EVENT_SETCONTACTSTATUS))
		{
			mt_setvar("$joinedvar", 'joined', 1, 0);

			iRC_HTML_Log_LogUsers($module, $channel, $info);
		}
	}

	return 0;
}

function iRC_HTML_Log_LogSave($module, $channel, $info, $output)
{
	if (empty($channel))
	{
		$channel = 'Global';
	}

	$dirname	= WWW_FULL_PATH .'/'. $info['profile'] .'/'. $info['date_dir_y'] .'/'. $info['date_dir_m'] .'/'. $info['date_dir_d'];
	$filename	= $dirname .'/'. $module .'_'. $info['network'] .'_'. $channel .'.hil';

	if (is_dir($dirname) === FALSE)
	{
		mkdirr($dirname);
	}

	$somecontent = $output . SYM_NEWLINE;

	if (!$handle = fopen($filename, 'a'))
	{
		$echo = SCRIPT_NAME .' ERROR:'. SYM_NEWLINE .'Cant open file:'. SYM_NEWLINE . $filename . SYM_NEWLINE;
		iRC_HTML_Log_ErrorTracker($echo);
	}

	if (fwrite($handle, $somecontent) === FALSE)
	{
		$echo = SCRIPT_NAME .' ERROR:'. SYM_NEWLINE .'Cant write to file:'. SYM_NEWLINE . $filename . SYM_NEWLINE;
		iRC_HTML_Log_ErrorTracker($echo);
	}

	fclose($handle);
}

function iRC_HTML_Log_Config()
{
	$dlg = mb_DlgCreate('HTML Log script settings:', 'iRC_HTML_Log_Callback', 300, 280,0,1); // $param, $flags;

	mb_DlgAddControl($dlg,	DC_STATIC,	' ',								5,5,285,70,		NULL,					SS_SUNKEN,							0);	//1000
	mb_DlgAddControl($dlg,	DC_STATIC,	'Currently Using:',					10,30,135,15,	NULL,					SS_LEFT,							0);	//1001
	mb_DlgAddControl($dlg,	DC_STATIC,	' Default style',					145,29,140,17,	NULL,					SS_LEFT | SS_SUNKEN,				0);	//1002
	mb_DlgAddControl($dlg,	DC_BUTTON,	'Use Chat style',					10,50,275,20,	'Callback_Style',		BF_MIDDLE | BS_FLAT | BS_VCENTER,	0);	//1003
	mb_DlgAddControl($dlg,	DC_BUTTON,	'About...',							10,230,80,20,	'Callback_About',		BF_MIDDLE | BS_FLAT | BS_VCENTER,	0);	//1004
	mb_DlgAddControl($dlg,	DC_STATIC,	'Log fonts and colors settings:',	10,10,275,15,	NULL,					SS_LEFT,							0);	//1005

	mb_DlgAddControl($dlg,	DC_STATIC,	' ',								5,80,285,70,	NULL,					SS_SUNKEN,							0);	//1006
	mb_DlgAddControl($dlg,	DC_STATIC,	'IRC Scripting support is...',		10,85,275,15,	NULL,					SS_LEFT,							0);	//1007
	mb_DlgAddControl($dlg,	DC_STATIC,	'<Error getting info>',				10,104,275,17,	NULL,					SS_LEFT | SS_SUNKEN,				0);	//1008
	mb_DlgAddControl($dlg,	DC_BUTTON,	'Enable for all',					10,125,275,20,	'Callback_EnableScr',	BF_MIDDLE | BS_FLAT | BS_VCENTER,	0);	//1009
	mb_DlgAddControl($dlg,	DC_BUTTON,	'?',								270,85,15,15,	'Callback_HelpScr',		BF_MIDDLE | BS_FLAT | BS_VCENTER,	0);	//1010
	mb_DlgAddControl($dlg,	DC_BUTTON,	'?',								270,10,15,15,	'Callback_HelpFiC',		BF_MIDDLE | BS_FLAT | BS_VCENTER,	0);	//1011

	mb_DlgAddControl($dlg,	DC_STATIC,	' ',								5,155,285,70,	NULL,					SS_SUNKEN,							0);	//1012
	mb_DlgAddControl($dlg,	DC_STATIC,	'Currently Using:',					10,180,135,15,	NULL,					SS_LEFT,							0);	//1013
	mb_DlgAddControl($dlg,	DC_STATIC,	' Domain only style',				145,179,140,17,	NULL,					SS_LEFT | SS_SUNKEN,				0);	//1014
	mb_DlgAddControl($dlg,	DC_BUTTON,	'Use Full link style',				10,200,275,20,	'Callback_LinkStyle',	BF_MIDDLE | BS_FLAT | BS_VCENTER,	0);	//1015
	mb_DlgAddControl($dlg,	DC_STATIC,	'Link parser settings:',			10,160,275,15,	NULL,					SS_LEFT,							0);	//1016
	mb_DlgAddControl($dlg,	DC_BUTTON,	'?',								270,160,15,15,	'Callback_HelpLink',	BF_MIDDLE | BS_FLAT | BS_VCENTER,	0);	//1017

	$res_chat_fic = mb_CSettingGet(NULL, SCRIPT_CFG, 'Chat_fic');
	if ($res_chat_fic == 0x01)
	{
		mb_DlgSetText($dlg, 1002, ' Chat style');
		mb_DlgSetText($dlg, 1003, 'Use Default style');
	}
	else if ($res_chat_fic == 0x00)
	{
		mb_DlgSetText($dlg, 1002, ' Default style');
		mb_DlgSetText($dlg, 1003, 'Use Chat style');
	}

	$res_link_style = mb_CSettingGet(NULL, SCRIPT_CFG, 'LinkStyle');
	if ($res_link_style == 0x01)
	{
		mb_DlgSetText($dlg, 1014, ' Full link style');
		mb_DlgSetText($dlg, 1015, 'Use Domain only style');
	}
	else if ($res_link_style == 0x00)
	{
		mb_DlgSetText($dlg, 1014, ' Domain only style');
		mb_DlgSetText($dlg, 1015, 'Use Full link style');
	}

	$ircs = mt_getvar('/irc/modules');
	foreach($ircs as $irc)
	{
		$res_scr_on = @mb_CSettingGet(NULL, $irc, 'ScriptingEnabled');
		$res_not_lim = @mb_CSettingGet(NULL, $irc, 'OnlineNotificationLimit');
		if ($res_scr_on == 0x01)
		{
			$scriptEn['on'][] = $irc;
		}
		else if ($res_scr_on === FALSE && $res_not_lim === FALSE)
		{
			$scriptEn['un'][] = $irc;
		}
		else if ($res_scr_on == 0x00 || ($res_scr_on === FALSE && $res_not_lim !== FALSE))
		{
			$scriptEn['off'][] = $irc;
		}
	}

	$s_un = @count($scriptEn['un']);
	$s_on = @count($scriptEn['on']);
	$s_off = @count($scriptEn['off']);
	mb_DlgSetText($dlg, 1008, ' Enabled:'. $s_on .' Disabled:'. $s_off .' Unsupported:'. $s_un);

	mb_DlgRun($dlg); 
	mb_DlgMove($dlg, NULL, 300, 200);
}

function iRC_HTML_Log_Callback($ok) 
{ 
	if ($ok == 0)	//cancel or close
	{
		return 1;
	}

	$dlg = mb_DlgGet(); 

	return 1; 
} 

function Callback_About($param1, $param2)
{
	mb_msgbox(
				'Script name:'. SYM_TAB . SCRIPT_NAME . SYM_NEWLINE .
				'Current version:'. SYM_TAB . SCRIPT_VERSION . SYM_NEWLINE .
				'Script authors:'. SYM_TAB .'CriS, Dionys' . SYM_NEWLINE .
				'Authors e-mail:'. SYM_TAB .'skiner@inbox.ru' . SYM_NEWLINE .
				SYM_NEWLINE . SYM_NEWLINE . SYM_NEWLINE .
				'Copyright:  2005 CriS,  2012 Dionys',
				SCRIPT_NAME .' About...'
	);
}

function Callback_LinkStyle($param1, $param2)
{
	$dlg = mb_DlgGet(); 

	$res_link_style = mb_CSettingGet(NULL, SCRIPT_CFG, 'LinkStyle');
	if ($res_link_style == 0x01)
	{
		mb_CSettingSet(NULL, SCRIPT_CFG, 'LinkStyle', 0x00);
		mb_DlgSetText($dlg, 1014, ' Domain only style');
		mb_DlgSetText($dlg, 1015, 'Use Full link style');
	}
	else if ($res_link_style == 0x00)
	{
		mb_CSettingSet(NULL, SCRIPT_CFG, 'LinkStyle', 0x01);
		mb_DlgSetText($dlg, 1014, ' Full link style');
		mb_DlgSetText($dlg, 1015, 'Use Domain only style');
	}
}

function Callback_Style($param1, $param2)
{
	$dlg = mb_DlgGet();

	$res_chat_fic = mb_CSettingGet(NULL, SCRIPT_CFG, 'Chat_fic');
	if ($res_chat_fic == 0x01)
	{
		mb_CSettingSet(NULL, SCRIPT_CFG, 'Chat_fic', 0x00);

		$res_check_style = iRC_HTML_Log_CheckStyle();
		if ($res_check_style === FALSE)
		{
			mb_CSettingSet(NULL, SCRIPT_CFG, 'Chat_fic', $res_chat_fic);
		}
		else
		{
			mb_DlgSetText($dlg, 1002, ' Default style');
			mb_DlgSetText($dlg, 1003, 'Use Chat style');
		}
	}
	else if ($res_chat_fic == 0x00)
	{
		mb_CSettingSet(NULL, SCRIPT_CFG, 'Chat_fic', 0x01);

		$res_check_style = iRC_HTML_Log_CheckStyle();
		if ($res_check_style === FALSE)
		{
			mb_CSettingSet(NULL, SCRIPT_CFG, 'Chat_fic', $res_chat_fic);
		}
		else
		{
			mb_DlgSetText($dlg, 1002, ' Chat style');
			mb_DlgSetText($dlg, 1003, 'Use Default style');
		}
	}
}

function Callback_EnableScr($param1, $param2)
{
	$dlg = mb_DlgGet(); 
	$ScrEn = '';
	$ircs = mt_getvar('/irc/modules');

	foreach($ircs as $irc)
	{
		$res_scr_on = @mb_CSettingGet(NULL, $irc, 'ScriptingEnabled');
		$res_not_lim = @mb_CSettingGet(NULL, $irc, 'OnlineNotificationLimit');
		if ($res_scr_on === FALSE && $res_not_lim === FALSE)
		{
			$ScrEn .= $irc . SYM_TAB .'Unsupported'. SYM_NEWLINE;
		}
		else if ($res_scr_on == 0x01)
		{
			$ScrEn .= $irc . SYM_TAB .'Allready Enabled'. SYM_NEWLINE;
		}
		else if ($res_scr_on === FALSE && $res_not_lim !== FALSE)
		{
			mb_CSettingAdd(NULL, $irc, DBVT_BYTE, 'ScriptingEnabled', 0x01);
			$res_scr_on = @mb_CSettingGet(NULL, $irc, 'ScriptingEnabled');
			if ($res_scr_on == 0x01)
			{
				$ScrEn .= $irc . SYM_TAB .'Succesfully Enabled'. SYM_NEWLINE;
			}
			else
			{
				$ScrEn .= $irc . SYM_TAB .'Failed [creating]...'. SYM_NEWLINE;
			}
		}
		else if ($res_scr_on == 0x00)
		{
			mb_CSettingSet(NULL, $irc, 'ScriptingEnabled', 0x01);
			$res_scr_on = @mb_CSettingGet(NULL, $irc, 'ScriptingEnabled');
			if ($res_scr_on == 0x01)
			{
				$ScrEn .= $irc . SYM_TAB .'Succesfully Enabled'. SYM_NEWLINE;
			}
			else
			{
				$ScrEn .= $irc . SYM_TAB .'Failed [setting]...'. SYM_NEWLINE;
			}
		}
	}

	mb_msgbox(
				'Operation complete.'. SYM_NEWLINE . SYM_NEWLINE .
				'Here is stats:'. SYM_NEWLINE .
				$ScrEn . SYM_NEWLINE .
				'If you have unsupported modules,'. SYM_NEWLINE .
				'you must update it.',
				SCRIPT_NAME .' Scripting support'
	);

	foreach($ircs as $irc)
	{
		$res_scr_on = @mb_CSettingGet(NULL, $irc, 'ScriptingEnabled');
		$res_not_lim = @mb_CSettingGet(NULL, $irc, 'OnlineNotificationLimit');
		if ($res_scr_on == 0x01)
		{
			$scriptEn['on'][] = $irc;
		}
		else if ($res_scr_on === FALSE && $res_not_lim === FALSE)
		{
			$scriptEn['un'][] = $irc;
		}
		else if ($res_scr_on == 0x00 || ($res_scr_on === FALSE && $res_not_lim !== FALSE))
		{
			$scriptEn['off'][] = $irc;
		}
	}

	$s_un	= @count($scriptEn['un']);
	$s_on	= @count($scriptEn['on']);
	$s_off	= @count($scriptEn['off']);
	mb_DlgSetText($dlg, 1008, ' Enabled:'. $s_on .' Disabled:'. $s_off .' Unsupported:'. $s_un);
}

function Callback_HelpScr($param1, $param2)
{
	mb_msgbox(
				'To use this script, you need to have IRC 0.6.3.* or later.'. SYM_NEWLINE .
				'Installed and activated scripting support!'. SYM_NEWLINE . SYM_NEWLINE .
				'You can activate it for all installed IRC modules by one click.',
				SCRIPT_NAME .' Help: Scripting support'
	);
}

function Callback_HelpFiC($param1, $param2)
{
	mb_msgbox(
				'Then you install script it uses its own default color'. SYM_NEWLINE .
				'settings to make logs. But script also can import your'. SYM_NEWLINE .
				'settings from Chat plugin. Just set it to <Chat style>.'. SYM_NEWLINE . SYM_NEWLINE .
				'You can switch it back if you need to do it.',
				SCRIPT_NAME .' Help: Log styles'
	);
}

function Callback_HelpLink($param1, $param2)
{
	mb_msgbox(
				'Link parser replaces all found URLs in log by usual links.'. SYM_NEWLINE .
				'By default it writes to link caption only domain name (e.g. miranda-im.org).'. SYM_NEWLINE .
				'You still can see full link by hovering it, title will be displayed.'. SYM_NEWLINE .
				'Here you can choose to use default Domain style or to use Full link'. SYM_NEWLINE .
				'style (e.g. http://www.miranda-im.org/download/details.php)',
				SCRIPT_NAME .' Help: Link parser'
	);
}

function iRC_HTML_Log_CheckStyle()
{
	$style = @file_get_contents(WWW_STYLE);
	if ($style === FALSE)
	{
		$echo = SCRIPT_NAME .' ERROR:'. SYM_NEWLINE .'Cant read file:'. SYM_NEWLINE . WWW_STYLE . SYM_NEWLINE;
		iRC_HTML_Log_ErrorTracker($echo);
	}

	$style_default	= @file_get_contents(WWW_STYLE_DEF);
	if ($style_default === FALSE)
	{
		$echo = SCRIPT_NAME .' ERROR:'. SYM_NEWLINE .'Cant read file:'. SYM_NEWLINE . WWW_STYLE_DEF . SYM_NEWLINE;
		iRC_HTML_Log_ErrorTracker($echo);
	}

	$res_chat_fic = @mb_CSettingGet(NULL, SCRIPT_CFG, 'Chat_fic');
	if ($res_chat_fic == 0x01)
	{
		$style_chat = iRC_HTML_Log_CreateStyle();
		if ($style_chat === FALSE)
		{
			$echo = SCRIPT_NAME .' ERROR:'. SYM_NEWLINE .'Seems like we cant import (CLC) chat color settings...'. SYM_NEWLINE;
			mb_PUAdd(NULL, SCRIPT_NAME, $echo, 0, 0, mb_IconLoadSys(IDI_WARNING));
			return FALSE;
		}

		if (strcmp($style, $style_chat) != 0)
		{
			$stylefile = @fopen(WWW_STYLE, 'w');
			if ($stylefile === FALSE)
			{
				$echo = SCRIPT_NAME .' ERROR:'. SYM_NEWLINE .'Cant open file:'. SYM_NEWLINE . WWW_STYLE . SYM_NEWLINE;
				iRC_HTML_Log_ErrorTracker($echo);
			}

			$res_write = @fwrite($stylefile, $style_chat);
			if ($res_write === FALSE)
			{
				$echo = SCRIPT_NAME .' ERROR:'. SYM_NEWLINE .'Cant write to file:'. SYM_NEWLINE . WWW_STYLE . SYM_NEWLINE;
				iRC_HTML_Log_ErrorTracker($echo);
			}

			fclose($stylefile);
		}
	}
	else if (strcmp($style, $style_default) != 0)
	{
		$stylefile = @fopen(WWW_STYLE, 'w');
		if ($stylefile === FALSE)
		{
			$echo = SCRIPT_NAME .' ERROR:'. SYM_NEWLINE .'Cant open file:'. SYM_NEWLINE . WWW_STYLE . SYM_NEWLINE;
			iRC_HTML_Log_ErrorTracker($echo);
		}

		$res_write = @fwrite($stylefile, $style_default);
		if ($res_write === FALSE)
		{
			$echo = SCRIPT_NAME .' ERROR:'. SYM_NEWLINE .'Cant write to file:'. SYM_NEWLINE . WWW_STYLE . SYM_NEWLINE;
			iRC_HTML_Log_ErrorTracker($echo);
		}

		fclose($stylefile);
	}

	return TRUE;
}

function iRC_HTML_Log_CreateStyle()
{
	$fic = iRC_HTML_Log_FontStyle();
	if ($fic === FALSE)
	{
		return FALSE;
	}

	$style_text = array(
		'body, table, tr, td, div, span, font {',
		'	background-color:	#'. $fic['Background'] .';',
		'	color:				#'. $fic['Incoming']['color'] .';',
		'	border:				0px solid;',
		'	border-color:		transparent;',
		'	margin:				0px;',
		'	padding:			0px;',
		'	font-family:		'. $fic['Incoming']['font'] .';',
		'	font-size:			'. $fic['Incoming']['size'] .';',
		'}',
		' ',
		'body {',
		'	padding:			10px;',
		'}',
		' ',
		'tr, td, span, div, font {',
		'	vertical-align:		top;',
		'	text-align:			left;',
		'}',
		' ',
		'tr {',
		'	margin:				-2px 1px -2px 0px;',
		'}',
		' ',
		'.Georgia {',
		'	font-family:		Georgia;',
		'	color:				#3333FF;',
		'}',
		'.Georgia:hover {',
		'	color:				#33FF33;',
		'}',
		' '
	);

	foreach($fic as $type => $set)
	{
		if ($type != 'Background')
		{
			$style_text[] = '.'. $type .' {';
			$style_text[] = '	color:				#'. $set['color'] .';';
			$style_text[] = '	font-family:		'. $set['font'] .';';
			$style_text[] = '	font-size:			'. $set['size'] .';';

			if ($set['style'] == 0x00)
			{
				$style_text[] = '	text-decoration:	none;';
				$style_text[] = '	font-weight:		normal;';
				$style_text[] = '	font-style:			normal;';
				
			}
			else if ($set['style'] == 0x01)
			{
				$style_text[] = '	text-decoration:	none;';
				$style_text[] = '	font-weight:		bold;';
				$style_text[] = '	font-style:			normal;';
				
			}
			else if ($set['style'] == 0x02)
			{
				$style_text[] = '	text-decoration:	none;';
				$style_text[] = '	font-weight:		normal;';
				$style_text[] = '	font-style:			italic;';
				
			}
			else if ($set['style'] == 0x03)
			{
				$style_text[] = '	text-decoration:	none;';
				$style_text[] = '	font-weight:		bold;';
				$style_text[] = '	font-style:			italic;';
				
			}

			$style_text[] = '	vertical-align:		top;';
			$style_text[] = '	text-align:			left;';
			$style_text[] = '	border:				0px solid;';
			$style_text[] = '	border-color:		transparent;';
			$style_text[] = '	margin:				0px;';
			$style_text[] = '	padding:			0px;';
			$style_text[] = '}';
			$style_text[] = ' ';
		}
	}

	$out_style_arr = array_merge($style_text, iRC_HTML_Log_Formatting());
	$out_style_str = implode(SYM_NEWLINE, $out_style_arr);

	return $out_style_str;
}

function iRC_HTML_Log_FontStyle()
{
	$cfg	= array();
	$fic	= array(array());

	if (_TABSRMM)
	{
		$cfg[0] = 'TabSRMM_Fonts';
		$cfg[1] = 'BkgColour';
		$cfg[2] = 'TabSRMM_chat_Fonts';
	}
	else
	{
		$cfg[0] = 'Chat';
		$cfg[1] = 'ColorLogBG';
		$cfg[2] = 'ChatFonts';
	}

	// BackGround Color
	$BkColour					= @mb_CSettingGet(NULL, $cfg[0], $cfg[1]);	if ($BkColour === FALSE)					return FALSE;
	$fic['Background']			= iRC_HTML_Log_ColorReverse(dechex($BkColour));
	// Timestamp
	$fic['Timestamp']['font']	= @mb_CSettingGet(NULL, $cfg[2], 'Font0');		if ($fic['Timestamp']['font'] === FALSE)	return FALSE;
	$fic['Timestamp']['style']	= @mb_CSettingGet(NULL, $cfg[2], 'Font0Sty');	if ($fic['Timestamp']['style'] === FALSE)	return FALSE;
	$Font0Col					= @mb_CSettingGet(NULL, $cfg[2], 'Font0Col');	if ($Font0Col === FALSE)					return FALSE;
	$fic['Timestamp']['color']	= iRC_HTML_Log_ColorReverse(dechex($Font0Col));
	$Font0Size					= @mb_CSettingGet(NULL, $cfg[2], 'Font0Size');	if ($Font0Size === FALSE)					return FALSE;
	$fic['Timestamp']['size']	= iRC_HTML_Log_SizeParser($Font0Size);
	// Nicks
	$fic['Nicks']['font']		= @mb_CSettingGet(NULL, $cfg[2], 'Font1');		if ($fic['Nicks']['font'] === FALSE)		return FALSE;
	$fic['Nicks']['style']		= @mb_CSettingGet(NULL, $cfg[2], 'Font1Sty');	if ($fic['Nicks']['style'] === FALSE)		return FALSE;
	$Font1Col					= @mb_CSettingGet(NULL, $cfg[2], 'Font1Col');	if ($Font1Col === FALSE)					return FALSE;
	$fic['Nicks']['color']		= iRC_HTML_Log_ColorReverse(dechex($Font1Col));
	$Font1Size					= @mb_CSettingGet(NULL, $cfg[2], 'Font1Size');	if ($Font1Size === FALSE)					return FALSE;
	$fic['Nicks']['size']		= iRC_HTML_Log_SizeParser($Font1Size);
	// MyNick
	$fic['MyNick']['font']		= @mb_CSettingGet(NULL, $cfg[2], 'Font2');		if ($fic['MyNick']['font'] === FALSE)		return FALSE;
	$fic['MyNick']['style']		= @mb_CSettingGet(NULL, $cfg[2], 'Font2Sty');	if ($fic['MyNick']['style'] === FALSE)		return FALSE;
	$Font2Col					= @mb_CSettingGet(NULL, $cfg[2], 'Font2Col');	if ($Font2Col === FALSE)					return FALSE;
	$fic['MyNick']['color']		= iRC_HTML_Log_ColorReverse(dechex($Font2Col));
	$Font2Size					= @mb_CSettingGet(NULL, $cfg[2], 'Font2Size');	if ($Font2Size === FALSE)					return FALSE;
	$fic['MyNick']['size']		= iRC_HTML_Log_SizeParser($Font2Size);
	// Join
	$fic['Join']['font']		= @mb_CSettingGet(NULL, $cfg[2], 'Font3');		if ($fic['Join']['font'] === FALSE)			return FALSE;
	$fic['Join']['style']		= @mb_CSettingGet(NULL, $cfg[2], 'Font3Sty');	if ($fic['Join']['style'] === FALSE)		return FALSE;
	$Font3Col					= @mb_CSettingGet(NULL, $cfg[2], 'Font3Col');	if ($Font3Col === FALSE)					return FALSE;
	$fic['Join']['color']		= iRC_HTML_Log_ColorReverse(dechex($Font3Col));
	$Font3Size					= @mb_CSettingGet(NULL, $cfg[2], 'Font3Size');	if ($Font3Size === FALSE)					return FALSE;
	$fic['Join']['size']		= iRC_HTML_Log_SizeParser($Font3Size);
	// Part
	$fic['Part']['font']		= @mb_CSettingGet(NULL, $cfg[2], 'Font4');		if ($fic['Part']['font'] === FALSE)			return FALSE;
	$fic['Part']['style']		= @mb_CSettingGet(NULL, $cfg[2], 'Font4Sty');	if ($fic['Part']['style'] === FALSE)		return FALSE;
	$Font4Col					= @mb_CSettingGet(NULL, $cfg[2], 'Font4Col');	if ($Font4Col === FALSE)					return FALSE;
	$fic['Part']['color']		= iRC_HTML_Log_ColorReverse(dechex($Font4Col));
	$Font4Size					= @mb_CSettingGet(NULL, $cfg[2], 'Font4Size');	if ($Font4Size === FALSE)					return FALSE;
	$fic['Part']['size']		= iRC_HTML_Log_SizeParser($Font4Size);
	// Disconnect
	$fic['Disconnect']['font']	= @mb_CSettingGet(NULL, $cfg[2], 'Font5');		if ($fic['Disconnect']['font'] === FALSE)	return FALSE;
	$fic['Disconnect']['style']	= @mb_CSettingGet(NULL, $cfg[2], 'Font5Sty');	if ($fic['Disconnect']['style'] === FALSE)	return FALSE;
	$Font5Col					= @mb_CSettingGet(NULL, $cfg[2], 'Font5Col');	if ($Font5Col === FALSE)					return FALSE;
	$fic['Disconnect']['color']	= iRC_HTML_Log_ColorReverse(dechex($Font5Col));
	$Font5Size					= @mb_CSettingGet(NULL, $cfg[2], 'Font5Size');	if ($Font5Size === FALSE)					return FALSE;
	$fic['Disconnect']['size']	= iRC_HTML_Log_SizeParser($Font5Size);
	// Kick
	$fic['Kick']['font']		= @mb_CSettingGet(NULL, $cfg[2], 'Font6');		if ($fic['Kick']['font'] === FALSE)			return FALSE;
	$fic['Kick']['style']		= @mb_CSettingGet(NULL, $cfg[2], 'Font6Sty');	if ($fic['Kick']['style'] === FALSE)		return FALSE;
	$Font6Col					= @mb_CSettingGet(NULL, $cfg[2], 'Font6Col');	if ($Font6Col === FALSE)					return FALSE;
	$fic['Kick']['color']		= iRC_HTML_Log_ColorReverse(dechex($Font6Col));
	$Font6Size					= @mb_CSettingGet(NULL, $cfg[2], 'Font6Size');	if ($Font6Size === FALSE)					return FALSE;
	$fic['Kick']['size']		= iRC_HTML_Log_SizeParser($Font6Size);
	// NickChange
	$fic['NickChange']['font']	= @mb_CSettingGet(NULL, $cfg[2], 'Font7');		if ($fic['NickChange']['font'] === FALSE)	return FALSE;
	$fic['NickChange']['style']	= @mb_CSettingGet(NULL, $cfg[2], 'Font7Sty');	if ($fic['NickChange']['style'] === FALSE)	return FALSE;
	$Font7Col					= @mb_CSettingGet(NULL, $cfg[2], 'Font7Col');	if ($Font7Col === FALSE)					return FALSE;
	$fic['NickChange']['color']	= iRC_HTML_Log_ColorReverse(dechex($Font7Col));
	$Font7Size					= @mb_CSettingGet(NULL, $cfg[2], 'Font7Size');	if ($Font7Size === FALSE)					return FALSE;
	$fic['NickChange']['size']	= iRC_HTML_Log_SizeParser($Font7Size);
	// Notice
	$fic['Notice']['font']		= @mb_CSettingGet(NULL, $cfg[2], 'Font8');		if ($fic['Notice']['font'] === FALSE)		return FALSE;
	$fic['Notice']['style']		= @mb_CSettingGet(NULL, $cfg[2], 'Font8Sty');	if ($fic['Notice']['style'] === FALSE)		return FALSE;
	$Font8Col					= @mb_CSettingGet(NULL, $cfg[2], 'Font8Col');	if ($Font8Col === FALSE)					return FALSE;
	$fic['Notice']['color']		= iRC_HTML_Log_ColorReverse(dechex($Font8Col));
	$Font8Size					= @mb_CSettingGet(NULL, $cfg[2], 'Font8Size');	if ($Font8Size === FALSE)					return FALSE;
	$fic['Notice']['size']		= iRC_HTML_Log_SizeParser($Font8Size);
	// Incoming
	$fic['Incoming']['font']	= @mb_CSettingGet(NULL, $cfg[2], 'Font9');		if ($fic['Incoming']['font'] === FALSE)		return FALSE;
	$fic['Incoming']['style']	= @mb_CSettingGet(NULL, $cfg[2], 'Font9Sty');	if ($fic['Incoming']['style'] === FALSE)	return FALSE;
	$Font9Col					= @mb_CSettingGet(NULL, $cfg[2], 'Font9Col');	if ($Font9Col === FALSE)					return FALSE;
	$fic['Incoming']['color']	= iRC_HTML_Log_ColorReverse(dechex($Font9Col));
	$Font9Size					= @mb_CSettingGet(NULL, $cfg[2], 'Font9Size');	if ($Font9Size === FALSE)					return FALSE;
	$fic['Incoming']['size']	= iRC_HTML_Log_SizeParser($Font9Size);
	// Outgoing
	$fic['Outgoing']['font']	= @mb_CSettingGet(NULL, $cfg[2], 'Font10');		if ($fic['Outgoing']['font'] === FALSE)		return FALSE;
	$fic['Outgoing']['style']	= @mb_CSettingGet(NULL, $cfg[2], 'Font10Sty');	if ($fic['Outgoing']['style'] === FALSE)	return FALSE;
	$Font10Col					= @mb_CSettingGet(NULL, $cfg[2], 'Font10Col');	if ($Font10Col === FALSE)					return FALSE;
	$fic['Outgoing']['color']	= iRC_HTML_Log_ColorReverse(dechex($Font10Col));
	$Font10Size					= @mb_CSettingGet(NULL, $cfg[2], 'Font10Size');	if ($Font10Size === FALSE)					return FALSE;
	$fic['Outgoing']['size']	= iRC_HTML_Log_SizeParser($Font10Size);
	// Topic
	$fic['Topic']['font']		= @mb_CSettingGet(NULL, $cfg[2], 'Font11');		if ($fic['Topic']['font'] === FALSE)		return FALSE;
	$fic['Topic']['style']		= @mb_CSettingGet(NULL, $cfg[2], 'Font11Sty');	if ($fic['Topic']['style'] === FALSE)		return FALSE;
	$Font11Col					= @mb_CSettingGet(NULL, $cfg[2], 'Font11Col');	if ($Font11Col === FALSE)					return FALSE;
	$fic['Topic']['color']		= iRC_HTML_Log_ColorReverse(dechex($Font11Col));
	$Font11Size					= @mb_CSettingGet(NULL, $cfg[2], 'Font11Size');	if ($Font11Size === FALSE)					return FALSE;
	$fic['Topic']['size']		= iRC_HTML_Log_SizeParser($Font11Size);
	// Info
	$fic['Info']['font']		= @mb_CSettingGet(NULL, $cfg[2], 'Font12');		if ($fic['Info']['font'] === FALSE)			return FALSE;
	$fic['Info']['style']		= @mb_CSettingGet(NULL, $cfg[2], 'Font12Sty');	if ($fic['Info']['style'] === FALSE)		return FALSE;
	$Font12Col					= @mb_CSettingGet(NULL, $cfg[2], 'Font12Col');	if ($Font12Col === FALSE)					return FALSE;
	$fic['Info']['color']		= iRC_HTML_Log_ColorReverse(dechex($Font12Col));
	$Font12Size					= @mb_CSettingGet(NULL, $cfg[2], 'Font12Size');	if ($Font12Size === FALSE)					return FALSE;
	$fic['Info']['size']		= iRC_HTML_Log_SizeParser($Font12Size);
	// AddStatus
	$fic['AddStatus']['font']	= @mb_CSettingGet(NULL, $cfg[2], 'Font13');		if ($fic['AddStatus']['font'] === FALSE)	return FALSE;
	$fic['AddStatus']['style']	= @mb_CSettingGet(NULL, $cfg[2], 'Font13Sty');	if ($fic['AddStatus']['style'] === FALSE)	return FALSE;
	$Font13Col					= @mb_CSettingGet(NULL, $cfg[2], 'Font13Col');	if ($Font13Col === FALSE)					return FALSE;
	$fic['AddStatus']['color']	= iRC_HTML_Log_ColorReverse(dechex($Font13Col));
	$Font13Size					= @mb_CSettingGet(NULL, $cfg[2], 'Font13Size');	if ($Font13Size === FALSE)					return FALSE;
	$fic['AddStatus']['size']	= iRC_HTML_Log_SizeParser($Font13Size);
	// RemStatus
	$fic['RemStatus']['font']	= @mb_CSettingGet(NULL, $cfg[2], 'Font14');		if ($fic['RemStatus']['font'] === FALSE)	return FALSE;
	$fic['RemStatus']['style']	= @mb_CSettingGet(NULL, $cfg[2], 'Font14Sty');	if ($fic['RemStatus']['style'] === FALSE)	return FALSE;
	$Font14Col					= @mb_CSettingGet(NULL, $cfg[2], 'Font14Col');	if ($Font14Col === FALSE)					return FALSE;
	$fic['RemStatus']['color']	= iRC_HTML_Log_ColorReverse(dechex($Font14Col));
	$Font14Size					= @mb_CSettingGet(NULL, $cfg[2], 'Font14Size');	if ($Font14Size === FALSE)					return FALSE;
	$fic['RemStatus']['size']	= iRC_HTML_Log_SizeParser($Font14Size);
	// Action
	$fic['Action']['font']		= @mb_CSettingGet(NULL, $cfg[2], 'Font15');		if ($fic['Action']['font'] === FALSE)		return FALSE;
	$fic['Action']['style']		= @mb_CSettingGet(NULL, $cfg[2], 'Font15Sty');	if ($fic['Action']['style'] === FALSE)		return FALSE;
	$Font15Col					= @mb_CSettingGet(NULL, $cfg[2], 'Font15Col');	if ($Font15Col === FALSE)					return FALSE;
	$fic['Action']['color']		= iRC_HTML_Log_ColorReverse(dechex($Font15Col));
	$Font15Size					= @mb_CSettingGet(NULL, $cfg[2], 'Font15Size');	if ($Font15Size === FALSE)					return FALSE;
	$fic['Action']['size']		= iRC_HTML_Log_SizeParser($Font15Size);
	// Hilight
	$fic['Hilight']['font']		= @mb_CSettingGet(NULL, $cfg[2], 'Font16');		if ($fic['Hilight']['font'] === FALSE)		return FALSE;
	$fic['Hilight']['style']	= @mb_CSettingGet(NULL, $cfg[2], 'Font16Sty');	if ($fic['Hilight']['style'] === FALSE)		return FALSE;
	$Font16Col					= @mb_CSettingGet(NULL, $cfg[2], 'Font16Col');	if ($Font16Col === FALSE)					return FALSE;
	$fic['Hilight']['color']	= iRC_HTML_Log_ColorReverse(dechex($Font16Col));
	$Font16Size					= @mb_CSettingGet(NULL, $cfg[2], 'Font16Size');	if ($Font16Size === FALSE)					return FALSE;
	$fic['Hilight']['size']		= iRC_HTML_Log_SizeParser($Font16Size);

	return $fic;
}

function iRC_HTML_Log_Formatting()
{
	$format = array(
		'.c00, .c01, .c02, .c03, .c04, .c05, .c06, .c07, .c08, .c09, .c10, .c11, .c12, .c13, .c14, .c15, .f00, .f01, .f02, .f03, .f04, .f05, .f06, .f07, .f08, .f09, .f10, .f11, .f12, .f13, .f14, .f15, .b, .i, .u {',
		'	border:				0px solid;',
		'	border-color:		transparent;',
		'	margin:				0px;',
		'	padding:			0px;',
		'}',
		' ',
		'.c00 {',
		'	color:				#FFFFFF;',
		'}',
		' ',
		'.c01 {',
		'	color:				#000000;',
		'}',
		' ',
		'.c02 {',
		'	color:				#00007F;',
		'}',
		' ',
		'.c03 {',
		'	color:				#009300;',
		'}',
		' ',
		'.c04 {',
		'	color:				#FF0000;',
		'}',
		' ',
		'.c05 {',
		'	color:				#7F0000;',
		'}',
		' ',
		'.c06 {',
		'	color:				#9C009C;',
		'}',
		' ',
		'.c07 {',
		'	color:				#FC7F00;',
		'}',
		' ',
		'.c08 {',
		'	color:				#FFFF00;',
		'}',
		' ',
		'.c09 {',
		'	color:				#00FC00;',
		'}',
		' ',
		'.c10 {',
		'	color:				#009393;',
		'}',
		' ',
		'.c11 {',
		'	color:				#00FFFF;',
		'}',
		' ',
		'.c12 {',
		'	color:				#0000FC;',
		'}',
		' ',
		'.c13 {',
		'	color:				#FF00FF;',
		'}',
		' ',
		'.c14 {',
		'	color:				#7F7F7F;',
		'}',
		' ',
		'.c15 {',
		'	color:				#D2D2D2;',
		'}',
		' ',
		'.f00 {',
		'	background-color:	#FFFFFF;',
		'}',
		' ',
		'.f01 {',
		'	background-color:	#000000;',
		'}',
		' ',
		'.f02 {',
		'	background-color:	#00007F;',
		'}',
		' ',
		'.f03 {',
		'	background-color:	#009300;',
		'}',
		' ',
		'.f04 {',
		'	background-color:	#FF0000;',
		'}',
		' ',
		'.f05 {',
		'	background-color:	#7F0000;',
		'}',
		' ',
		'.f06 {',
		'	background-color:	#9C009C;',
		'}',
		' ',
		'.f07 {',
		'	background-color:	#FC7F00;',
		'}',
		' ',
		'.f08 {',
		'	background-color:	#FFFF00;',
		'}',
		' ',
		'.f09 {',
		'	background-color:	#00FC00;',
		'}',
		' ',
		'.f10 {',
		'	background-color:	#009393;',
		'}',
		' ',
		'.f11 {',
		'	background-color:	#00FFFF;',
		'}',
		' ',
		'.f12 {',
		'	background-color:	#0000FC;',
		'}',
		' ',
		'.f13 {',
		'	background-color:	#FF00FF;',
		'}',
		' ',
		'.f14 {',
		'	background-color:	#7F7F7F;',
		'}',
		' ',
		'.f15 {',
		'	background-color:	#D2D2D2;',
		'}',
		' ',
		'.b {',
		'	font-weight:		bold;',
		'}',
		' ',
		'.i {',
		'	font-style:			italic;',
		'}',
		' ',
		'.u {',
		'	text-decoration:	underline;',
		'}',
		' '
	);

	return $format;
}

function iRC_HTML_Log_ColorReverse($color)
{
	switch(strlen($color))
	{
		case 1:
			$color = '00000'. $color;
			break;
		case 2:
			$color = '0000'. $color;
			break;
		case 3:
			$color = '000'. $color;
			break;
		case 4:
			$color = '00'. $color;
			break;
		case 5:
			$color = '0'. $color;
			break;
		default:
			break;
	}

	$color = substr($color, 4, 2) . substr($color, 2, 2) . substr($color, 0, 2);

	return $color;
}

function iRC_HTML_Log_SizeParser($size)
{
	switch(intval($size))
	{
		case 253 :
			$size = '2pt';
			break;
		case 251 :
			$size = '4pt';
			break;
		case 252 :
			$size = '3pt';
			break;
		case 249 :
			$size = '5pt';
			break;
		case 248 :
			$size = '6pt';
			break;
		case 247 :
			$size = '7pt';
			break;
		case 245 :
			$size = '8pt';
			break;
		case 244 :
			$size = '9pt';
			break;
		case 243 :
			$size = '10pt';
			break;
		case 241 :
			$size = '11pt';
			break;
		case 240 :
			$size = '12pt';
			break;
		case 239 :
			$size = '13pt';
			break;
		case 237 :
			$size = '14pt';
			break;
		default :
			$size = '16pt';
			break;
	}

	return $size;
}

function  iRC_HTML_Log_BackupUsers($module, $channel)
{
	if (strtolower($channel) != 'global' && !empty($channel))
	{
		$users_here		= mb_IrcGetData($module, "userlist|$channel");
		$users			= explode(' ', $users_here);
		$users_count	= count($users);
		$usersvar		= '/'. SCRIPT_CFG .'/'. $module .'/'. $channel .'/users';

		for ($i = 0; $i < $users_count; $i ++)
		{
			if (empty($users[$i]))
			{
				unset($users[$i]);
			}
		}
		$users = array_values($users);

		natcasesort($users);
		$users = array_values($users);

		mt_setvar("$usersvar", $users, 1, 0);
	}
}

function  iRC_HTML_Log_SetUsers($module, $eventtype, $channel, $info)
{
	switch($eventtype)
	{
		case GC_EVENT_JOIN:
		{
			if (strtolower($channel) != 'global' && !empty($channel))
			{
				$usersvar	= '/'. SCRIPT_CFG .'/'. $module .'/'. $channel .'/users';
				$users		= @mt_getvar("$usersvar");

				array_push($users, $info['nick']);
				natcasesort($users);
				$users = array_values($users);

				mt_setvar("$usersvar", $users, 1, 0);

				iRC_HTML_Log_LogUsers($module, $channel, $info);
			}

			break;
		}
		case GC_EVENT_PART:
		case GC_EVENT_KICK:
		{
			if (strtolower($channel) != 'global' && !empty($channel))
			{
				$usersvar	= '/'. SCRIPT_CFG .'/'. $module .'/'. $channel .'/users';
				$users		= @mt_getvar("$usersvar");
				$key		= array_search($info['nick'], $users);
				if ($key !== FALSE)
				{
					unset($users[$key]);
					$users = array_values($users);

					mt_setvar("$usersvar", $users, 1, 0);

					iRC_HTML_Log_LogUsers($module, $channel, $info);
				}
			}

			break;
		}
		case GC_EVENT_QUIT:
		{
			$channellist = mb_IrcGetData($module, 'channellist');
			$channels = explode(' ', $channellist);
			foreach($channels as $channel)
			{
				if (!empty($channel))
				{
					$usersvar	= '/'. SCRIPT_CFG .'/'. $module .'/'. $channel .'/users';
					$users		= @mt_getvar("$usersvar");
					$key		= array_search($info['nick'], $users);
					if ($key !== FALSE)
					{
						unset($users[$key]);
						$users = array_values($users);

						mt_setvar("$usersvar", $users, 1, 0);

						iRC_HTML_Log_LogUsers($module, $channel, $info);
					}
				}
			}

			break;
		}
		case GC_EVENT_NICK:
		{
			$channellist = mb_IrcGetData($module, 'channellist');
			$channels = explode(' ', $channellist);
			foreach($channels as $channel)
			{
				if (!empty($channel))
				{
					$usersvar	= '/'. SCRIPT_CFG .'/'. $module .'/'. $channel .'/users';
					$users		= @mt_getvar("$usersvar");
					$key		= array_search($info['nick'], $users);
					if ($key !== FALSE)
					{
						$users[$key] = $info['text'];
						natcasesort($users);
						$users = array_values($users);

						mt_setvar("$usersvar", $users, 1, 0);

						iRC_HTML_Log_LogUsers($module, $channel, $info);
					}
				}
			}

			break;
		}
		default:
		{
			break;
		}
	}
}

function  iRC_HTML_Log_LogSaveToAllByUser($module, $channel, $info, $output)
{
	$channel = 'Global';
	iRC_HTML_Log_LogSave($module, $channel, $info, $output);

	$channellist = mb_IrcGetData($module, 'channellist');
	$channels = explode(' ', $channellist);
	foreach($channels as $channel)
	{
		if (!empty($channel))
		{
			$usersvar	= '/'. SCRIPT_CFG .'/'. $module .'/'. $channel .'/users';
			$users		= @mt_getvar("$usersvar");
			$key		= array_search($info['nick'], $users);
			if ($key !== FALSE)
			{
				iRC_HTML_Log_LogSave($module, $channel, $info, $output);
			}
		}
	}
}

function  iRC_HTML_Log_LogSaveToAll($module, $channel, $info, $output)
{
	$channel = 'Global';
	iRC_HTML_Log_LogSave($module, $channel, $info, $output);

	$channellist = mb_IrcGetData($module, 'channellist');
	$channels = explode(' ', $channellist);
	foreach($channels as $channel)
	{
		if (!empty($channel))
		{
			iRC_HTML_Log_LogSave($module, $channel, $info, $output);
		}
	}
}

function  iRC_HTML_Log_LogUsers($module, $channel, $info)
{
	if (strtolower($channel) != 'global' && !empty($channel))
	{
		$usersvar		= '/'. SCRIPT_CFG .'/'. $module .'/'. $channel .'/users';
		$users			= @mt_getvar("$usersvar");
		$users_count	= count($users);
		$users_here		= '';

		for ($i = 0; $i < $users_count; $i ++)
		{
			$users_here .= $users[$i] .' ';
		}

		$output = '<tr><td class=Timestamp>'. $info['date_dt'] .'</td><td class=Info>'. mb_SysTranslate($users_count .' Users on ['. $channel .']: '. $users_here) .'</td></tr>'. SYM_NEWLINE;
		iRC_HTML_Log_LogSave($module, $channel, $info, $output);
	}
}

function  iRC_HTML_Log_ErrorTracker($echo)
{
	if (_DEBUG)
	{
		mb_echo($echo);
	}

	mb_PUAdd(NULL, SCRIPT_NAME, $echo, 0, 0, mb_IconLoadSys(IDI_WARNING));

	exit;
}
?>